;; This LISP stuff is pretty much borrowed from MicroGUI.
;; I think I know how it works now...

(let*
    ;; Update window title pixel length
    ((title-width
      (lambda (w)
	(let
	    ((w-width (car (window-dimensions w))))
	  (max 0 (min (- w-width 100) (text-width (window-name w)))))))

     (bottom-images (make-image "bottom.png"))

     (top-left-images (list (make-image "top_left_inactive.png")
			    (make-image "top_left.png")))
     (top-left-shaped-images (list (make-image "top_left_inactive_s.png")
				   (make-image "top_left_s.png")))

     (top-hot-images (list (make-image "top_hot_inactive.png")
			    (make-image "top_hot.png")))

     (top-cut-images (list (make-image "top_cut_inactive.png")
			      (make-image "top_cut.png")))

     (top-grey-images (make-image "top_grey.png"))

     (top-right-images (make-image "top_right.png"))
     (top-right-shaped-images (make-image "top_right_s.png"))

     (bottom-left-images (make-image "bottom_left.png"))

     (bottom-right-images (make-image "bottom_right.png"))

     (close-images (list (make-image "close_normal.png")
			 (make-image "close_active.png") nil
			 (make-image "close_clicked.png")))

     (maximize-images (list (make-image "maximize_normal.png")
			    (make-image "maximize_active.png") nil
			    (make-image "maximize_clicked.png")))

     (iconify-images (list (make-image "minimize_normal.png")
			   (make-image "minimize_active.png") nil
			   (make-image "minimize_clicked.png")))

     (menu-images (list (make-image "menu_normal.png")
			(make-image "menu_active.png") nil
			(make-image "menu_clicked.png")))

     (left-images (make-image "left.png"))

     (right-images (make-image "right.png"))

     (top-images (flip-image-diagonally (copy-image left-images)))

     (text-colors '("white" "white"))


     (frame `(((background . ,top-left-images)
	       (left-edge . -5)
	       (top-edge . -18)
	       (class . top-left-corner))

	      ;; top hot
	      ((background . ,top-hot-images)
	       (foreground . ,text-colors)
	       (text . ,window-name)
	       (x-justify . 3)
	       (y-justify . center)
	       (top-edge . -18)
	       (left-edge . 15)
	       (width . ,(lambda (w) (+ (title-width w) 7)))
	       (class . title))

	      ;; menu button
	      ((background . ,menu-images)
	       (top-edge . -18)
	       (left-edge . 0)
	       (class . menu-button))

	      ;; top cut
	      ((background . ,top-cut-images)
	       (left-edge . ,(lambda (w) (+ (title-width w) 22)))
	       (top-edge . -18)
	       (class . title))

	      ;; top grey
	      ((background . ,top-grey-images)
	       (top-edge . -18)
	       (left-edge . ,(lambda (w) (+ (title-width w) 28)))
	       (right-edge . 40)
	       (class . title))

	      ;; left border
	      ((background . ,left-images)
	       (left-edge . -5)
	       (top-edge . 13)
	       (bottom-edge . 0)
	       (class . left-border))

	      ;; top-right corner
	      ((background . ,top-right-images)
	       (right-edge . -5)
	       (top-edge . -18)
	       (class . top-right-corner))

	      ;; right border
	      ((background . ,right-images)
	       (right-edge . -5)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))

	      ;; bottom border
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -5)
	       (class . bottom-border))

	      ;; bottom-left corner
	      ((background . ,bottom-left-images)
	       (left-edge . -5)
	       (bottom-edge . -5)
	       (class . bottom-left-corner))

	      ;; bottom-right corner
	      ((background . ,bottom-right-images)
	       (right-edge . -5)
	       (bottom-edge . -5)
	       (class . bottom-right-corner))

	      ;; iconify button
	      ((background . ,iconify-images)
	       (right-edge . 26)
	       (top-edge . -18)
	       (class . iconify-button))

	      ;; maximize button
	      ((background . ,maximize-images)
	       (right-edge . 12)
	       (top-edge . -18)
	       (class . maximize-button))

	      ;; delete button
	      ((background . ,close-images)
	       (right-edge . -1)
	       (top-edge . -18)
	       (class . close-button))))

       (shaped-frame `(((background . ,top-left-shaped-images)
			(left-edge . -5)
			(top-edge . -18)
			(height . 18)
			(class . top-left-corner))

		       ;; top hot
		       ((background . ,top-hot-images)
			(foreground . ,text-colors)
			(text . ,window-name)
			(x-justify . 3)
			(y-justify . center)
			(top-edge . -18)
			(left-edge . 15)
			(width . ,(lambda (w) (+ (title-width w) 7)))
			(class . title))

		       ;; menu button
		       ((background . ,menu-images)
			(top-edge . -18)
			(left-edge . 0)
			(class . menu-button))

		       ;; top cut
		       ((background . ,top-cut-images)
			(left-edge . ,(lambda (w) (+ (title-width w) 22)))
			(top-edge . -18)
			(class . title))

		       ;; top grey
		       ((background . ,top-grey-images)
			(top-edge . -18)
			(left-edge . ,(lambda (w) (+ (title-width w) 28)))
			(right-edge . 40)
			(class . title))

		       ;; top-right corner
		       ((background . ,top-right-shaped-images)
			(right-edge . -5)
			(top-edge . -18)
			(height . 18)
			(class . top-right-corner))

		       ;; iconify button
		       ((background . ,iconify-images)
			(right-edge . 26)
			(top-edge . -18)
			(class . iconify-button))

		       ;; maximize button
		       ((background . ,maximize-images)
			(right-edge . 12)
			(top-edge . -18)
			(class . maximize-button))

		       ;; delete button
		       ((background . ,close-images)
			(right-edge . -1)
			(top-edge . -18)
			(class . close-button))))

     (transient-frame `(((background . ,top-left-images)
	       (left-edge . -5)
	       (top-edge . -18)
	       (class . top-left-corner))

	      ;; top hot
	      ((background . ,top-hot-images)
	       (foreground . ,text-colors)
	       (text . ,window-name)
	       (x-justify . 3)
	       (y-justify . center)
	       (top-edge . -18)
	       (left-edge . 0)
	       (width . ,(lambda (w) (+ (title-width w) 7)))
	       (class . title))

	      ;; top cut
	      ((background . ,top-cut-images)
	       (left-edge . ,(lambda (w) (+ (title-width w) 7)))
	       (top-edge . -18)
	       (class . title))

	      ;; top grey
	      ((background . ,top-grey-images)
	       (top-edge . -18)
	       (left-edge . ,(lambda (w) (+ (title-width w) 13)))
	       (right-edge . 12)
	       (class . title))

	      ;; left border
	      ((background . ,left-images)
	       (left-edge . -5)
	       (top-edge . 13)
	       (bottom-edge . 0)
	       (class . left-border))

	      ;; top-right corner
	      ((background . ,top-right-images)
	       (right-edge . -5)
	       (top-edge . -18)
	       (class . top-right-corner))

	      ;; right border
	      ((background . ,right-images)
	       (right-edge . -5)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))

	      ;; bottom border
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -5)
	       (class . bottom-border))

	      ;; bottom-left corner
	      ((background . ,bottom-left-images)
	       (left-edge . -5)
	       (bottom-edge . -5)
	       (class . bottom-left-corner))

	      ;; bottom-right corner
	      ((background . ,bottom-right-images)
	       (right-edge . -5)
	       (bottom-edge . -5)
	       (class . bottom-right-corner))

	      ;; delete button
	      ((background . ,close-images)
	       (right-edge . -1)
	       (top-edge . -18)
	       (class . close-button))))

       (shaped-transient-frame `(((background . ,top-left-shaped-images)
			(left-edge . -5)
			(top-edge . -18)
			(height . 18)
			(class . top-left-corner))

		       ;; top hot
		       ((background . ,top-hot-images)
			(foreground . ,text-colors)
			(text . ,window-name)
			(x-justify . 3)
			(y-justify . center)
			(top-edge . -18)
			(left-edge . 0)
			(width . ,(lambda (w) (+ (title-width w) 7)))
			(class . title))

		       ;; top cut
		       ((background . ,top-cut-images)
			(left-edge . ,(lambda (w) (+ (title-width w) 7)))
			(top-edge . -18)
			(class . title))

		       ;; top grey
		       ((background . ,top-grey-images)
			(top-edge . -18)
			(left-edge . ,(lambda (w) (+ (title-width w) 13)))
			(right-edge . 12)
			(class . title))

		       ;; top-right corner
		       ((background . ,top-right-shaped-images)
			(right-edge . -5)
			(top-edge . -18)
			(height . 18)
			(class . top-right-corner))

		       ;; delete button
		       ((background . ,close-images)
			(right-edge . -1)
			(top-edge . -18)
			(class . close-button)))))



  (add-frame-style 'mavosBox
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((transient) transient-frame)
		       ((shaped) shaped-frame)
		       ((shaped-transient) shaped-transient-frame))))

  (call-after-property-changed
   'WM_NAME (lambda ()
	      (rebuild-frames-with-style 'mavosBox))))
